/*********************************************************
**                                                      **
**      FixCDID.rexx V1.1 -- Fixes a CD ID directory    **
**                                                      **
**********************************************************
**
**      (C) 1996 Richard Krber -- All Rights Reserved
**      E-Mail: rkoerber@tfh.dssd.sub.org
**
*********************************************************/

Options Results
Options FailAt 6

Shell
Say "-- FixCDID V1.1 -- (C) 1996 Richard Krber"
Say
Say "Getting file list, please be patient..."
'C:list NOHEAD QUICK TO t:idlist'
Say
counter = 0

IF Open('list','t:idlist','read') THEN
DO
  DO FOREVER
    filename = ReadLn('list')
    IF ~Eof('list') THEN
    DO
      uppername = Upper(filename)
      IF Left(uppername,2) = 'ID' THEN
      DO
        IF uppername ~= filename THEN
          'C:rename QUIET "'||filename||'" AS "'||uppername||'"'
        IF Open('file',uppername,'read') THEN
        DO
          pname  = Compress(ReadLn('file'),'"')
          cdname = pname||': '||Compress(ReadLn('file'),'"')
          CALL Close('file')
          IF uppername = Upper(pname) THEN
          DO
            IF Open('file',uppername,'read') THEN
            DO
              IF Open('newf','t:newf','write') THEN
              DO
                CALL ReadLn('file')
                title = ReadLn('file')
                PARSE VAR title pname ' - ' cdname
                CALL WriteLn('newf',pname)
                CALL WriteLn('newf',cdname)
                DO FOREVER
                  track = ReadLn('file')
                  IF ~EOF('file')
                    THEN CALL WriteLn('newf',track)
                    ELSE BREAK
                END
                CALL Close('file')
                CALL Close('newf')
                'C:copy QUIET "t:newf" TO "'||uppername||'"'
                'C:delete QUIET "t:newf"'
                pname  = Compress(pname,'"')
                cdname = pname||': '||Compress(cdname,'"')
              END
            END
          END
          cdname = DelStr(cdname,80)
          Say uppername||': '||cdname
          'C:filenote QUIET "'||uppername||'" COMMENT "'||cdname||'"'
          counter = counter + 1
        END
      END
      ELSE Say '** WARNING: '||filename||' is NOT an ID file!'
    END
    ELSE BREAK
  END
  CALL Close('list')
END

Say
Say "Number of CD entries:" counter

'C:delete QUIET t:idlist'
Shell
Exit


